/* rsys.c */
void About(void);
void HandleMainPort(void);
void main(int argc, char **argv);

/* rsysbroker.c */
void InstallBroker(void);
void RemoveBroker(void);
struct Screen *FindFrontPubScr(struct Screen *activescr);
void HandleBrokerPort(void);

/* rsysdoslists.c */
void MakeAssignList(void);
void MakeVolumeList(void);
void RSysLockList(void);
void SysResidentList(void);
void SysCLIList(void);
void SysResidentProg(void);

/* rsysexeclists.c */
void MakeLibList(void);
void MakeResList(void);
void MakeIntrList(void);
void MakePortList(void);
void MakeTaskList(void);
void SysSemaphoreList(void);
void SysVectorList(void);
void SysSoftDeviceList(void);

/* rsysextern.c */
int GetFile(struct Window *wind, char *dir, char *file, char *pattern, char *title, char *oktext);
void SaveList(struct Window *wind, char *filename, char *title, struct List *list, int withheader);
int SysStarted(int type);
void RemoveSpeech(void);
int InitSpeech(void);
void Speak(char *text);

/* rsysfiletype.c */
int filetype(char *Name);

/* rsysgfxintuilists.c */
void MakeFontList(void);
void MakeWindowList(void);
void MakeScreenList(void);
void SysPubScreenList(void);
void RSysGetDisplayModes(void);
void SysTOFWaitList(void);
void SysBlitterWaitList(void);
void RSysGadgetList(void);

/* rsyshandlerlist.c */
void MakeHandlerList(void);

/* rsysdisplays.c */
int DisplayDiskInfo(char *filename, int with_tree);
int DisplayFileInfo(char *filename);
void DisplayDirectoryInfo(char *filename);
int DisplayTaskInfo(struct objectid *obj);
int DisplayLibraryInfo(struct objectid *obj);
void DisplaySoftDevInfo(struct objectid *obj);
void DisplayResourceInfo(struct objectid *obj);
int DisplayPortInfo(struct objectid *obj);
int DisplayFontInfo(struct objectid *obj);
int DisplayWindowInfo(struct objectid *obj);
int DisplayScreenInfo(struct objectid *obj);

/* rsysformatfind.c */
int OpenFindFileWindow(void);
void FindFile(void);
int OpenFormatDiskWindow(void);
void FormatDisk(void);

/* rsyscrc.c */
int OpenCRCWindow(void);
void CRCSum(void);

/* rsyssavewindow.c */
void SaveWindows(void);

/* rsyssignaltrap.c */
void HandleTrap(int signal);
void InstallTrapHandlers(void);
void RemoveTrapHandlers(void);
void _traphandler(long sig);

/* rsystextformatter.c */
int RSysFormatOutput(char *format);

/* rsysintuictrl.c */
void *LockWindow(struct Window *win);
void UnlockWindow(void *req);
void EnableGadget(struct Window *Wnd, struct Gadget *gad, int on_off);
void makelabelvisible(struct Gadget *gad);
char *gadgetbuff(struct Gadget *gad);
void DisableSysRequest(int disable);
void MakeWindowRefresh(struct Window *window);
void RefreshMainWindowPattern(void);
void InitListView(struct Window *wind, struct Gadget *gad, struct List *list, int top);
void RefreshListView(void);
void EmptyListView(void);
void ClearIntuiMsgPort(struct Window *wnd);
void PrintHeader(enum ListTypes type, char *text);
void PrintInfo(char *text, int speakit, int waitit);
void PrintStatistics(void);
short MyEasyRequest(struct Window *wind, unsigned char *title, unsigned char *Gadgets, unsigned char *Body, ...);
void OpenMainWindow(void);
void CloseASysWindow(struct Window **wind, struct Gadget **windgadlist, struct Menu **windmenus);
int OpenASysWindow(int (*func)(void), int kill);
void CenterWindow(struct Screen *scr, unsigned short *top, unsigned short *left, unsigned short width, unsigned short height);

/* rsysgfxctrl.c */
int TextLen(struct TextFont *tf, struct RastPort *RP, char *text);
short compute(unsigned short offset, unsigned short xy, int measure);
unsigned short ComputeX(unsigned short value);
unsigned short ComputeY(unsigned short value);
void ComputeFont(struct Screen *wndscr, unsigned short width, unsigned short height);

/* rsyshelp.c */
void Help(void);

/* rsysiconify.c */
int LookTypeOfFile(long lock, char *fname, int num, int totalnum);
void Iconify(void);

/* rsysinit.c */
void RefreshRastPort(struct Window *wind, struct Gadget **gads, int *gadnum, int cnt);
long SetupScreen(void);
void CloseDownScreen(void);
int OpenSysWindow(void);

/* rsyslist.c */
int CountIntuiObjects(int typ);
int CountDevices(long mask);
int CountNodes(struct List *list);
int CountMemory(void);
int NoEntries(void);
void RefreshList(int type);
void SaveCurrentList(void);
void RestoreList(void);
void KillList(void);

/* rsysspeciallist.c */
void RSysAmigaGuideRefList(void);
void SysBrokerList(void);
void SysAvailFontsList(void);

/* rsyssummarylists.c */
void MakeHardwareList(void);
void MakeMemoryList(void);
void MakeSystemList(void);

/* rsysutils.c */
char *strncpy(char *dest, char const *src, unsigned long len);
char *strcpy(char *dest, char const *src);
void *MyAllocVec(unsigned long byteSize, unsigned long requirements, int kill);
void MyFreeVec(void *memptr);
long Command(struct Node *node, char *file);
void ToggleFastMode(void);
void ToggleAskingMode(void);
void ToggleSortMode(void);
void ToggleWorkingBar(void);
void ToggleSpeakMode(void);
void ToggleAutoFront(void);
void ToggleMouseWindow(void);
void ToggleTopazFont(void);
void AddNodeSorted(struct List *list, struct Node *node);
void AddNodeToList(int i, int sort_in);
void CreateEntryList(int sorting);
char *B2CStr(char *ret, long inp);
void savestrcpy(char *str, struct Node *node, int cnt, int type);
struct Node *GetNode(struct List *list, unsigned long offset);
long SizeOfFile(char *Name);
int SizeOfDir(long lock, long *Size, int *Dirs);
struct SE *AllocScrollEntries(int count);
long getdisktype(long lock);
void FreeBytes(char *Vol, long *free, long *used, long *usedpercent, char *state, char *type);
int exist(char *name);
void quit(int askyou);
int Question(struct Window *wind, char *ask, int def);
void OpenLibs(void);
void CloseLibs(void);
void CloseAll(void);

/* rsysmodify.c */
void CountAssocObjects(struct Task *task, int *wins, int *scrs, int *ports);
int CheckWindow(struct Window *findwin);
void ModifyObject(int TypeID, unsigned long code);

/* rsysaction.c */
void BuildActionList(void);
int StartAction(int ftype, char *file, short last);

/* rsyscrypt.c */
int OpenCryptWindow(void);
void CryptFile(void);

/* rsyshunks.c */
void PrintHunkStruct(char *file);
void HunkStruct(void);

/* rsystreehunks.c */
short ClickedCloseGadget(void);
long OpenTreeWindow(char *name, int hunk);
void PrintTree(struct objectid *obj);

/* rsyscheckoffsets.c */
void PrintLibOffsets(struct _liblist *liblist);
void PrintDevOffsets(struct _devlist *devlist);
void SysCheckOffs(void);

/* rsysclip.c */
void SaveListToClip(struct List *list, char *text);
void RSysListToClip(void);
void RSysEntryToClip(void);

/* rsysflush.c */
void RSysFlushAllLibraries(void);
void RSysFlushAllFonts(void);
void RSysFlushAll(void);

/* rsyserror.c */
void ErrorHandleFull(enum err_objects errobj, enum err_actions erract, int kill, char *file, char *func, int line);

/* rsyspreferencelists.c */
void MakeHeadEntry(int *num, char *title);
void MakeHexEntry(int *num, char *title, void *entry);
void SysPrefList(void);
void SysEnvList(void);
void SysExtPrinterData(void);

/* rsysshowfont.c */
void ShowFont(struct TextFont *tf);

